DRBDADM(8)

NAME
drbdadm - Administration tool for DRBD

SYNOPSIS

drbdadm [-d] [-c {file}] [-t {file}] [-s {cmd}] [-m {cmd}] [-S] [-h {host}] [-- {backend-options}] {command} [{all} | {resource[/volume>]...}]

DESCRIPTION

Drbdadm is the high level tool of the DRBD program suite. Drbdadm is to drbdsetup and drbdmeta what ifup/ifdown is to ifconfig. Drbdadm reads its configuration file and performs the specified commands by calling the drbdsetup and/or the drbdmeta program.

Drbdadm can operate on whole resources or on individual volumes in a resource. The sub commands: attach, detach, primary, secondary, invalidate, invalidate-remote, outdate, resize, verify, pause-sync, resume-sync, role, csytate, dstate, create-md, show-gi, get-gi, dump-md, wipe-md work on whole resources and on individual volumes.

Resource level only commands are: connect, disconnect, up, down, wait-connect and dump.

OPTIONS

-d, --dry-run
    Just prints the calls of drbdsetup to stdout, but does not run the commands.

-c, --config-file file
    Specifies the configuration file drbdadm will use. If this parameter is not specified, drbdadm will look for /etc/drbd-84.conf, /etc/drbd-83.conf, /etc/drbd-08.conf and /etc/drbd.conf.

-t, --config-to-test file
    Specifies an additional configuration file drbdadm to check. This option is only allowed with the dump and the sh-nop commands.

-s, --drbdsetup file
    Specifies the full path to the drbdsetup program. If this option is omitted, drbdadm will look for it beneath itself first, and then in the PATH.

-m, --drbdmeta file
    Specifies the full path to the drbdmeta program. If this option is omitted, drbdadm will look for it beneath itself first, and then in the PATH.

-S, --stacked
    Specifies that this command should be performed on a stacked resource.

-P, --peer
    Specifies to which peer node to connect. Only necessary if there are more than two host sections in the resource you are working on.

-- backend-options
    All options following the doubly hyphen are considered backend-options. These are passed through to the backend command. I.e. to drbdsetup, drbdmeta or drbd-proxy-ctl.

COMMANDS

attach
    Attaches a local backing block device to the DRBD resource's device.

detach
    Removes the backing storage device from a DRBD resource's device.

connect
    Sets up the network configuration of the resource's device. If the peer device is already configured, the two DRBD devices will connect. If there are more than two host sections in the resource you need to use the --peer option to select the peer you want to connect to.

disconnect
    Removes the network configuration from the resource. The device will then go into StandAlone state.

syncer
    Loads the resynchronization parameters into the device.

up
    Is a shortcut for attach and connect.

down
    Is a shortcut for disconnect and detach.

primary
    Promote the resource's device into primary role. You need to do this before any access to the device, such as creating or mounting a file system.

secondary
    Brings the device back into secondary role. This is needed since in a connected DRBD device pair, only one of the two peers may have primary role (except if allow-two-primaries is explicitly set in the configuration file).

invalidate
    Forces DRBD to consider the data on the local backing storage device as out-of-sync. Therefore DRBD will copy each and every block from its peer, to bring the local storage device back in sync. To avoid races, you need an established replication link, or be disconnected Secondary.

invalidate-remote
    This command is similar to the invalidate command, however, the peer's backing storage is invalidated and hence rewritten with the data of the local node. To avoid races, you need an established replication link, or be disconnected Primary.

resize
    Causes DRBD to re-examine all sizing constraints, and resize the resource's device accordingly. For example, if you increased the size of your backing storage devices (on both nodes, of course), then DRBD will adopt the new size after you called this command on one of your nodes. Since new storage space must be synchronised this command only works if there is at least one primary node present.

    Note that all of the following options are backend-options (i.e., separated via "--").

    The --size option can be used to online shrink the usable size of a drbd device. It's the users responsibility to make sure that a file system on the device is not truncated by that operation. Example:

        # drbdadm -- --size=10G resize r0

    The --assume-peer-has-space allows you to resize a device which is currently not connected to the peer. Use with care, since if you do not resize the peer's disk as well, further connect attempts of the two will fail.

    The --assume-clean allows you to resize an existing device and avoid syncing the new space. This is useful when adding addtional blank storage to your device. Example:

        # drbdadm -- --assume-clean resize r0

    The options --al-stripes and --al-stripe-size-kB may be used to change the layout of the activity log online. In case of internal meta data this may invovle shrinking the user visible size at the same time (unsing the --size) or increasing the avalable space on the backing devices.

check-resize
    Calls drbdmeta to eventually move internal meta data. If the backing device was resized, while DRBD was not running, meta data has to be moved to the end of the device, so that the next attach command can succeed.

create-md
    Initializes the meta data storage. This needs to be done before a DRBD resource can be taken online for the first time. In case of issues with that command have a look at drbdmeta(8)

get-gi
    Shows a short textual representation of the data generation identifiers.

show-gi
    Prints a textual representation of the data generation identifiers including explanatory information.

dump-md
    Dumps the whole contents of the meta data storage, including the stored bit-map and activity-log, in a textual representation.

outdate
    Sets the outdated flag in the meta data.

adjust
    Synchronizes the configuration of the device with your configuration file. You should always examine the output of the dry-run mode before actually executing this command.

wait-connect
    Waits until the device is connected to its peer device.

role
    Shows the current roles of the devices (local/peer). E.g. Primary/Secondary

state
    Deprecated alias for "role", see above.

cstate
    Shows the current connection state of the devices.

dump
    Just parse the configuration file and dump it to stdout. May be used to check the configuration file for syntactic correctness.

outdate
    Used to mark the node's data as outdated. Usually used by the peer's fence-peer handler.

verify
    Starts online verify. During online verify, data on both nodes is compared for equality. See /proc/drbd for online verify progress. If out-of-sync blocks are found, they are not resynchronized automatically. To do that, disconnect and connect the resource when verification has completed.

    See also the notes on data integrity on the drbd.conf manpage.

pause-sync
    Temporarily suspend an ongoing resynchronization by setting the local pause flag. Resync only progresses if neither the local nor the remote pause flag is set. It might be desirable to postpone DRBD's resynchronization until after any resynchronization of the backing storage's RAID setup.

resume-sync
    Unset the local sync pause flag.

new-current-uuid
    Generates a new currend UUID and rotates all other UUID values.

    This can be used to shorten the initial resync of a cluster. See the drbdsetup manpage for a more details.

dstate
    Show the current state of the backing storage devices. (local/peer)

hidden-commands
    Shows all commands undocumented on purpose.

VERSION

This document was revised for version 8.4.0 of the DRBD distribution.

AUTHOR

Written by Philipp Reisner <philipp.reisner@linbit.com> and Lars Ellenberg <lars.ellenberg@linbit.com>

REPORTING BUGS

Report bugs to <drbd-user@lists.linbit.com>.

COPYRIGHT

Copyright 2001-2011 LINBIT Information Technologies, Philipp Reisner, Lars Ellenberg. This is free software; see the source for copying conditions. There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

SEE ALSO

drbd.conf(5), drbd(8), drbddisk(8), drbdsetup(8), drbdmeta(8) and the DRBD project web site[1]

NOTES

1.  DRBD project web site
    http://www.drbd.org/